# TODO:
# - check running
# - 2.5 -> 3.0 migration?
# - more docs from http://www.firebirdsql.org/en/reference-manuals/ ?
# - kill unaligned accesses (create_db,gpre_current,gbak_static,isql_static) on alpha
#   - check if it's fixed now (RISC_ALIGNMENT is defined)
# - check classic subpackage pre/post scripts
# - logrotate script
# - create SYSDBA user with initial password before first firebird start
#   eg.:
#     su firebird
#     echo "create user SYSDBA password 'masterkey';"|fb_isql -u SYSDBA /var/lib/firebird/security3.fdb
#
Summary:	Firebird SQL Database Server and Client tools
Summary(de.UTF-8):	Firebird - relationalen Open-Source- Datenbankmanagementsystems
Summary(pl.UTF-8):	Firebird - serwer baz danych SQL oraz narzędzia klienckie
Name:		Firebird
Version:	3.0.2.32703
Release:	1
License:	Interbase Public License 1.0, Initial Developer's Public License 1.0
Group:		Applications/Databases
Source0:	http://downloads.sourceforge.net/firebird/%{name}-%{version}-0.tar.bz2
# Source0-md5:	1fdc121ab04d2c2772d778e45ecd5689
Source1:	http://www.firebirdsql.org/file/documentation/reference_manuals/user_manuals/Firebird-3-QuickStart.pdf
# Source1-md5:	8e029d449e9cb3e1da8213ac6c11ad02
# distfiles refuses this, would require some audit to allow '('/')' chars
#Source2:	http://www.firebirdsql.org/pdfmanual/Using-Firebird_(wip).pdf
## Source2-md5:	9eb90583c200bdd7292a80ecc1df1178
Source3:	http://www.firebirdsql.org/pdfmanual/%{name}-Null-Guide.pdf
# Source3-md5:	d1f8ba75fe3bb9eb9d203ce3f82a1a1a
Source4:	http://www.firebirdsql.org/pdfmanual/%{name}-Generator-Guide.pdf
# Source4-md5:	44e7568ef477072a8ad5f381c3e12a75
Source5:	http://www.firebirdsql.org/pdfmanual/MSSQL-to-%{name}.pdf
# Source5-md5:	1bd4a168e550910fc899e2aa125d83a3
Source6:	http://www.firebirdsql.org/pdfmanual/%{name}-nbackup.pdf
# Source6-md5:	7ef8a8b9a899d06bec2a5da0bb5fea0e
Source7:	http://www.firebirdsql.org/pdfmanual/%{name}-Utils-WIP.pdf
# Source7-md5:	39b9a4f3c9d9e27d985e9277ae163ceb
Source8:	http://www.firebirdnews.org/docs/fb2min.pdf
# Source8-md5:	ebac312c0afbe97b1850bdc74c553c28
Source9:	http://www.firebirdsql.org/doc/contrib/fb_2_1_errorcodes.pdf
# Source9-md5:	9ab392dc349657dbcf9a9c35acd8e8db
Source100:	firebird.init
Source101:	firebird.sysconfig
Source102:	firebird.inetd
Source103:	firebird.tmpfiles
Source104:	firebird.service
Source105:	firebird-classic.service
Source106:	firebird-classic.socket
Source107:	server_mode-ss.conf
Source108:	server_mode-classic.conf
Patch0:		%{name}-chmod.patch
Patch1:		%{name}-editline.patch
Patch2:		%{name}-va.patch
Patch3:		%{name}-FHS.patch
Patch4:		%{name}-opt.patch
Patch5:		%{name}-gcc-icu.patch
Patch6:		%{name}-libpath.patch
Patch7:		Make-the-generated-code-compatible-with-gcc-6-in-C-1.patch
Patch8:		Provide-sized-global-delete-operators-when-compiled.patch
Patch9:		parallel-build.patch
Patch10:	no-copy-from-icu.patch
Patch11:	config.patch
URL:		http://www.firebirdsql.org/
BuildRequires:	autoconf >= 2.67
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	libatomic_ops
BuildRequires:	libedit-devel
BuildRequires:	libicu-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtommath-devel
BuildRequires:	libtool >= 2:2
# for lockfile
BuildRequires:	procmail
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
BuildRequires:	zlib-devel
Requires:	%{name}-dirs = %{version}-%{release}
Requires:	%{name}-lib = %{version}-%{release}
# official ports are x86, x86_64, ppc, sparc, arm, mips/mipsel, ia64
# alpha is added in morearchs patch
# see morearchs patch if you want more
ExclusiveArch:	%{ix86} %{x8664} x32 arm ia64 mips mipsel ppc sparc sparcv9 alpha
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		ibdir	%{_libdir}/interbase
%define		specflags	-fno-strict-aliasing
%define		debugcflags	-O1 -g -Wall -fno-strict-aliasing
%define		Werror_cflags	''

%description
Firebird is a powerful, high-performance relational database designed
to be embedded into applications on multiple platforms.

%description -l pl.UTF-8
Firebird jest potężnym, wysoko wydajnym systemem relacyjnych baz
danych zaprojektowanym do osadzania w aplikacjach na wielu
platformach.

%description -l de.UTF-8
Firebird ist der Open-Source-Spin-Off des weiterhin kommerziell von
Borland vertriebenen relationalen Datenbankmanagementsystemes
InterBase. Die Abspaltung erfolgte im Jahre 2000 als kurz vor Freigabe
der Version 6 des kommerziellen Vorgängers Interbase bei Borland
ernsthafte Überlegungen im Gange waren, die Weiterentwicklung
einzustellen.

Aus Interbase 6.0 wurde Firebird 1.0, wobei dies als eine
Bugfix-Version mit nur wenigen Erweiterungen angesehen werden kann.
Eine Erweiterung von Firebird 1.0 ist der 64-Bit File I/O, so dass
auch Datenbankdateien über 2GB erzeugt werden können.

%package dirs
Summary:	Firebird SQL Database common directories
Summary(pl.UTF-8):	Firebird - wspólne katalogi
Group:		Applications/Databases

%description dirs
Firebird SQL Database common directories.

%description dirs -l pl.UTF-8
Firebird - wspólne katalogi.

%package lib
Summary:	Firebird shared library
Summary(pl.UTF-8):	Biblioteka współdzielona Firebird
Group:		Libraries

%description lib
Firebird shared library (libgds).

%description lib -l pl.UTF-8
Biblioteka współdzielona Firebird (libgds).

%package devel
Summary:	Header files for Firebird library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki Firebird
Group:		Development/Libraries
Requires:	%{name}-dirs = %{version}-%{release}
Requires:	%{name}-lib = %{version}-%{release}
Requires:	libstdc++-devel
Obsoletes:	Firebird-static

%description devel
Header files for Firebird library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki Firebird.

%package doc
Summary:	Extensive InterBase and Firebird documentation
Summary(pl.UTF-8):	Obszerna dokumentacja do baz InterBase i Firebird
Group:		Documentation

%description doc
Extensive InterBase and Firebird documentation.

%description doc -l pl.UTF-8
Obszerna dokumentacja do baz InterBase i Firebird.

%package ss
Summary:	Firebird Superserver init scripts
Group:		Applications/Databases
Requires:	%{name} = %{version}-%{release}
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts

%description ss
Firebird Superserver init scripts.

%package classic
Summary:	Firebird Classic init scripts
Group:		Applications/Databases
Requires:	%{name} = %{version}-%{release}

%description classic
Firebird Classic init scripts.

%prep
%setup -q -n %{name}-%{version}-0
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p0
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

mkdir docs
cp %{SOURCE1} %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7} %{SOURCE8} %{SOURCE9} docs

# not processed by configure
%{__sed} -i -e 's/^CFLAGS.*$/& %{rpmcflags} %{rpmcppflags}/' extern/btyacc/Makefile
%{__sed} -i -e 's/^\(CC\|LINKER\)\(.*= \)gcc$/\1\2 %{__cc}/' extern/btyacc/Makefile

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}

%configure \
	CFLAGS="%{rpmcflags} -fno-delete-null-pointer-checks" \
	--prefix=%{ibdir} \
	--with-system-editline \
	--with-fbconf=%{_sysconfdir}/firebird \
	--with-fbinclude=%{_includedir} \
	--with-fblib=%{_libdir} \
	--with-fblog=/var/log \
	--with-fbsecure-db=/var/lib/firebird \
	--with-fbglock=/var/lib/firebird \
	--with-gnu-ld \
	--with-gpre-pascal \
	--with-system-editline \
	%{?debug:--enable-debug} \
	--disable-rpath \
	--disable-binreloc

%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C src -f ../gen/Makefile.install buildImageDir

install -d $RPM_BUILD_ROOT%{_sysconfdir}/{firebird{,/conf.d},rc.d/init.d,sysconfig/rc-inetd}
install -d $RPM_BUILD_ROOT{%{_bindir},%{ibdir},%{_libdir},%{_includedir}} \
install -d $RPM_BUILD_ROOT/var/{log,lib/firebird} \
	$RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/tmpfiles.d
install -d $RPM_BUILD_ROOT%{systemdunitdir}
cp -p %{SOURCE103} $RPM_BUILD_ROOT%{_sysconfdir}/tmpfiles.d/firebird.conf
touch $RPM_BUILD_ROOT/var/log/firebird.log

cd gen/buildroot
cp -p var/lib/firebird/security3.fdb $RPM_BUILD_ROOT/var/lib/firebird
cp -p etc/firebird/*.conf $RPM_BUILD_ROOT%{_sysconfdir}/firebird
chmod 755 usr/include/firebird/impl
cp -pr usr/include/* $RPM_BUILD_ROOT%{_includedir}
cp -dp usr/%{_lib}/*.so* $RPM_BUILD_ROOT%{_libdir}
cd .%{ibdir}
cp -a UDF bin help intl plugins firebird.msg $RPM_BUILD_ROOT%{ibdir}
ln -s %{ibdir}/intl $RPM_BUILD_ROOT%{_sysconfdir}/firebird
ln -s %{ibdir}/{UDF,bin,plugins,firebird.msg} $RPM_BUILD_ROOT%{_sysconfdir}/firebird
chmod u+w -R examples # allow further cleaning
cp -rf examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

ln -sf libfbclient.so.2 $RPM_BUILD_ROOT%{_libdir}/libgds.so.0
ln -sf libfbclient.so.2 $RPM_BUILD_ROOT%{_libdir}/libgds.so

for f in bin/{fb_lock_print,gbak,gfix,gpre,gsec,gsplit,gstat,nbackup}; do
	ln -sf %{ibdir}/$f $RPM_BUILD_ROOT%{_bindir}/${f#bin/}
done
ln -sf %{ibdir}/bin/isql $RPM_BUILD_ROOT%{_bindir}/fb_isql

rm -f $RPM_BUILD_ROOT%{ibdir}/bin/{FirebirdUninstall.sh,changeServerMode.sh}

sed -e 's|/usr/lib|%{_libdir}|' %{SOURCE100} >$RPM_BUILD_ROOT/etc/rc.d/init.d/firebird
cp -p %{SOURCE101} $RPM_BUILD_ROOT/etc/sysconfig/firebird
sed -e 's|/usr/lib|%{_libdir}|' %{SOURCE104} >$RPM_BUILD_ROOT%{systemdunitdir}/firebird.service
install -d $RPM_BUILD_ROOT/var/run/firebird

sed -e 's|/usr/lib|%{_libdir}|' %{SOURCE102} >$RPM_BUILD_ROOT/etc/sysconfig/rc-inetd/firebird
sed -e 's|/usr/lib|%{_libdir}|' %{SOURCE105} >$RPM_BUILD_ROOT%{systemdunitdir}/firebird-classic@.service
cp -p %{SOURCE106} $RPM_BUILD_ROOT%{systemdunitdir}/firebird-classic.socket

cp -p %{SOURCE107} $RPM_BUILD_ROOT%{_sysconfdir}/firebird/conf.d/
cp -p %{SOURCE108} $RPM_BUILD_ROOT%{_sysconfdir}/firebird/conf.d/

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 145 firebird
%useradd -u 145 -d %{ibdir} -s /bin/sh -g firebird -c "Firebird Server" firebird

%postun
if [ "$1" = "0" ]; then
	%userremove firebird
	%groupremove firebird
fi

%post	lib -p /sbin/ldconfig
%postun	lib -p /sbin/ldconfig

%post ss
/sbin/chkconfig --add firebird
%service firebird restart
%systemd_post firebird.service

%preun ss
if [ "$1" = "0" ]; then
	%service firebird stop
	/sbin/chkconfig --del firebird
fi
%systemd_preun firebird.service

%postun ss
%systemd_reload

%post classic
%systemd_post firebird-classic@.service firebird-classic.socket

%preun classic
%systemd_preun firebird-classic@.service firebird-classic.socket

%postun classic
%systemd_reload

%triggerpostun -- %{name} < 2.1.1.17910-2
if [ -f %{ibdir}/firebird.conf.rpmsave ]; then
	mv -f %{ibdir}/firebird.conf.rpmsave %{_sysconfdir}/firebird/firebird.conf
fi

%files
%defattr(644,root,root,755)
%doc doc/{license,sql.extensions,Firebird_conf.txt,README.user*,WhatsNew,fb2-todo.txt}
%dir %{_sysconfdir}/firebird
%dir %{_sysconfdir}/firebird/conf.d
%attr(640,root,firebird) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/firebird/databases.conf
%attr(640,root,firebird) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/firebird/fbtrace.conf
%attr(640,root,firebird) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/firebird/firebird.conf
%attr(640,root,firebird) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/firebird/plugins.conf
%{_sysconfdir}/firebird/intl
%{_sysconfdir}/firebird/UDF
%{_sysconfdir}/firebird/bin
%{_sysconfdir}/firebird/firebird.msg
%{_sysconfdir}/firebird/plugins
%attr(755,root,root) %{_bindir}/fb_isql
%attr(755,root,root) %{_bindir}/fb_lock_print
%attr(755,root,root) %{_bindir}/gbak
%attr(755,root,root) %{_bindir}/gfix
%attr(755,root,root) %{_bindir}/gsec
%attr(755,root,root) %{_bindir}/gsplit
%attr(755,root,root) %{_bindir}/gstat
%attr(755,root,root) %{_bindir}/nbackup
%attr(755,root,root) %{_libdir}/libib_util.so
%attr(755,root,root) %{ibdir}/UDF
%attr(755,root,root) %{ibdir}/bin/*
%exclude %{ibdir}/bin/fb_config
%exclude %{ibdir}/bin/gpre
%exclude %{ibdir}/bin/fbguard
%{ibdir}/help
%dir %attr(770,root,firebird) %{ibdir}/intl
%attr(755,root,root) %{ibdir}/intl/fbintl
# should it be moved to %{_sysconfdir} and marked as config?
%{ibdir}/intl/fbintl.conf
%dir %{ibdir}/plugins
%attr(755,root,root) %{ibdir}/plugins/libfbtrace.so
%attr(755,root,root) %{ibdir}/plugins/libCryptKeyHolder_example.so
%attr(755,root,root) %{ibdir}/plugins/libDbCrypt_example.so
%attr(755,root,root) %{ibdir}/plugins/libEngine12.so
%attr(755,root,root) %{ibdir}/plugins/libLegacy_Auth.so
%attr(755,root,root) %{ibdir}/plugins/libLegacy_UserManager.so
%attr(755,root,root) %{ibdir}/plugins/libSrp.so
%attr(755,root,root) %{ibdir}/plugins/libudr_engine.so
%dir %{ibdir}/plugins/udr
%attr(755,root,root) %{ibdir}/plugins/udr/libudrcpp_example.so
%{ibdir}/plugins/udr_engine.conf

%{ibdir}/firebird.msg
%dir %attr(770,root,firebird) /var/lib/firebird
%attr(660,root,firebird) %config(noreplace) %verify(not md5 mtime size) /var/lib/firebird/security3.fdb
%attr(660,root,firebird) %config(noreplace) %verify(not md5 mtime size) /var/log/firebird.log


%files dirs
%defattr(644,root,root,755)
%dir %{ibdir}
%dir %{ibdir}/bin

%files lib
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfbclient.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libfbclient.so.2

# InterBase/old Firebird compatibility symlinks
%attr(755,root,root) %{_libdir}/libgds.so.0
# needed here - original libgds.so.0 didn't have soname, so some old
# (possibly not open-source) apps may be linked with libgds.so
%attr(755,root,root) %{_libdir}/libgds.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfbclient.so
%attr(755,root,root) %{ibdir}/bin/fb_config
%attr(755,root,root) %{ibdir}/bin/gpre
%attr(755,root,root) %{_bindir}/gpre
%{_includedir}/firebird
%{_includedir}/ib_util.h
%{_includedir}/ibase.h
%{_includedir}/iberror.h
%{_includedir}/perf.h
%{_examplesdir}/%{name}-%{version}

%files doc
%defattr(644,root,root,755)
%doc docs/*

%files ss
%defattr(644,root,root,755)
%attr(640,root,firebird) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/firebird/conf.d/server_mode-ss.conf
%attr(754,root,root) /etc/rc.d/init.d/firebird
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/firebird
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/tmpfiles.d/firebird.conf
%attr(755,root,root) %{ibdir}/bin/fbguard
%dir %attr(770,root,firebird) /var/run/firebird
%{systemdunitdir}/firebird.service

%files classic
%defattr(644,root,root,755)
%attr(640,root,firebird) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/firebird/conf.d/server_mode-classic.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/rc-inetd/firebird
%{systemdunitdir}/firebird-classic@.service
%{systemdunitdir}/firebird-classic.socket
%changelog
* Thu Apr 06 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/Firebird.git;a=log;h=master

* Tue Apr 04 2017 Bartek Szady <bszx@bszx.eu> aacfabf
- updated to 3.0.2.32703
- added classic and superserver (ss) subpackages

* Mon Feb 20 2017 Jan Rękorajski <baggins@pld-linux.org> 919264b
- rel 1

* Thu Feb 02 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 8f47d69
- up to 3.0.1.32609; patches from FC and Debian

* Sat Sep 03 2016 Jakub Bogusz <qboosh@pld-linux.org> d8c389b
- started update to 3.0.0 (2.5.x left on Firebird-2.5 branch)
- updated editline,va,chmod,FHS,opt,noroot patches
- removed rpath patch (use configure option instead)
- added libadd patch (place Firebird runtime as first LD_LIBRARY_PATH component)
- adjusted init script and inetd config (not tested yet)

* Tue Aug 30 2016 Jakub Bogusz <qboosh@pld-linux.org> 734522b
- updated to 2.4.6.27020
- actually package intl etc symlink
- fb_lock_mgr seems now stopped by default

* Sun May 15 2016 Elan Ruusamäe <glen@delfi.ee> 4204cc8
- icu-57.1 rebuild
- release 3 (by relup.sh)

* Mon Nov 16 2015 Jan Rękorajski <baggins@pld-linux.org> 50d0d78
- release 2 (by relup.sh)

* Fri May 29 2015 Jakub Bogusz <qboosh@pld-linux.org> f5058bc
- updated to 2.5.4.26856
- updated FHS,opt patches

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 714f864
- x32 rebuild
- release 5 (by relup.sh)

* Sat Jan 03 2015 Jan Rękorajski <baggins@pld-linux.org> f220d6a
- build on x32

* Wed Oct 08 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 4ef7f92
- release 4 (by relup.sh)

* Fri Jan 24 2014 Jan Rękorajski <baggins@pld-linux.org> 894b33a
- fix daemon path in inetd config
- link intl dir to etc for internationalization to work
- rel 3

* Fri Nov 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 050b704
- release 2 (by relup.sh)

* Sat Apr 13 2013 Jakub Bogusz <qboosh@pld-linux.org> 19f3dea
- updated to 2.5.2.26540
- updated noroot patch
- removed obsolete svn patch

* Wed Sep 19 2012 Jakub Bogusz <qboosh@pld-linux.org> e3271c9
- readded opt patch to avoid some unwanted flags

* Wed Sep 19 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 89d82bc
- rel 2; correct patch

* Wed Sep 19 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> f5811ef
- rel 2; correct patch

* Wed Sep 19 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 81ff231
- up to 2.5.1.26351; drop obsolete or unneded patches

* Wed Sep 19 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 5f46e31
- release 8 (by relup.sh)

* Sat Jul 07 2012 hawk <hawk@pld-linux.org> 732b89f
- release 7

